﻿using FarPoint.Win.Spread;
using FarPoint.Win.Spread.CellType;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace MergedRowPrefHeight
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            var textCell = new TextCellType();
            textCell.WordWrap = true;

            fpSpread1.ActiveSheet.Cells[1, 0].ColumnSpan = 3;
            fpSpread1.ActiveSheet.Cells[1, 0].CellType = textCell;

            fpSpread1.ActiveSheet.Cells[4, 0].ColumnSpan = 3;
            fpSpread1.ActiveSheet.Cells[4, 0].RowSpan = 3;
            fpSpread1.ActiveSheet.Cells[4, 0].CellType = textCell;

            fpSpread1.ActiveSheet.CellChanged += ActiveSheet_CellChanged;

            fpSpread1.ActiveSheet.Cells[1, 0].Value = "It is similar to ref keyword. But the main difference between ref and out keyword is that ref needs that the variable must be initialized before it passed to the method.";
            fpSpread1.ActiveSheet.Cells[4, 0].Value = "It is similar to ref keyword. But the main difference between ref and out keyword is that ref needs that the variable must be initialized before it passed to the method.";

            fpSpread1.EnterCell += FpSpread1_EnterCell;
        }

        private void FpSpread1_EnterCell(object sender, EnterCellEventArgs e)
        {
            Console.WriteLine($"RowHeight = {fpSpread1.ActiveSheet.Rows[e.Row].Height}");
        }

        private void ActiveSheet_CellChanged(object sender, SheetViewEventArgs e)
        {
            TextCellType textCell = fpSpread1.ActiveSheet.Cells[e.Row, e.Column].CellType as TextCellType;
            if (textCell != null && textCell.WordWrap)
            {
                int modelRow = fpSpread1.ActiveSheet.GetModelRowFromViewRow(e.Row);
                int modelCol = fpSpread1.ActiveSheet.GetModelColumnFromViewColumn(e.Column);

                StyleInfo styleInfo = new StyleInfo();
                fpSpread1.ActiveSheet.Models.Style.GetCompositeInfo(modelRow, modelCol, -1, styleInfo);
                var renderer = styleInfo.Renderer;
                if (renderer == null)
                {
                    SpreadSkin spreadSkin = (fpSpread1 != null) ? fpSpread1.DefaultSkin : null;
                    renderer = spreadSkin.Renderer;
                }
                FarPoint.Win.Spread.Appearance appearance = new FarPoint.Win.Spread.Appearance();
                styleInfo.GetAppearance(appearance);
                float zoomFactor = fpSpread1.ZoomFactor;
                object value = fpSpread1.ActiveSheet.Models.Data.GetValue(modelRow, modelCol);

                using (Graphics graphics = Graphics.FromHwnd((IntPtr)0))
                {
                    var range = fpSpread1.AsWorkbook().ActiveSheet.Cells[e.Row, e.Column].MergeArea;
                    if (range.RowCount > 1)
                    {
                        float rowHeight = 0, colWidth = 0;
                        for (int row = range.Row; row <= range.Row2; ++row)
                        {
                            rowHeight += fpSpread1.ActiveSheet.Rows[row].Height;
                        }
                        for (int col = range.Column; col <= range.Column2; ++col)
                        {
                            colWidth += fpSpread1.ActiveSheet.Columns[col].Width;
                        }
                        rowHeight -= (range.RowCount - 1) * fpSpread1.ActiveSheet.VerticalGridLine.Width > 0 ?
                            fpSpread1.ActiveSheet.VerticalGridLine.Width : 1;
                        colWidth -= (range.ColumnCount - 1) * fpSpread1.ActiveSheet.HorizontalGridLine.Width > 0 ?
                            fpSpread1.ActiveSheet.HorizontalGridLine.Width : 1;
                        Size size = new Size((int)colWidth, (int)rowHeight);
                        size = renderer.GetPreferredSize(graphics, size, appearance, value, zoomFactor);

                        float newHeight = size.Height;
                        for (int row = range.Row + 1; row <= range.Row2; ++row)
                        {
                            newHeight -= fpSpread1.ActiveSheet.Rows[row].Height;
                        }
                        newHeight += (range.RowCount - 1) * fpSpread1.ActiveSheet.VerticalGridLine.Width > 0 ?
                            fpSpread1.ActiveSheet.VerticalGridLine.Width : 1;

                        fpSpread1.ActiveSheet.Rows[e.Row].Height = Math.Max(newHeight, fpSpread1.ActiveSheet.Rows.Default.Height);
                    }
                    else
                    {
                        fpSpread1.ActiveSheet.Rows[e.Row].Height = fpSpread1.ActiveSheet.GetPreferredRowHeight(e.Row);
                    }
                }
            }
        }
    }
}
